#include "otabrowse5.h"
#pragma hdrstop

#include "formeditor.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormEditorForm *FormEditorForm;
//---------------------------------------------------------------------------
__fastcall TFormEditorForm::TFormEditorForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormEditorForm::FormShow(TObject *Sender)
{ bRefresh->Click();
  //
  Caption=AnsiString("FormEditor - ")+ExtractFileName(fe->GetFileName());
  eFileName->Text=fe->GetFileName();
  eModified->Text=BoolToString(fe->GetModified());
}
//---------------------------------------------------------------------------
void __fastcall TFormEditorForm::bMarkModifiedClick(TObject *Sender)
{ fe->MarkModified();
  eModified->Text=BoolToString(fe->GetModified());
}
//---------------------------------------------------------------------------
void __fastcall TFormEditorForm::bGetModuleClick(TObject *Sender)
{ _di_IOTAModule m = fe->GetModule();
  if (m==NULL) Application->MessageBox("Module not found","Get Module",MB_OK);
  else ShowModule(this,m);
}
//---------------------------------------------------------------------------
void __fastcall TFormEditorForm::bShowClick(TObject *Sender)
{ fe->Show();
}
//---------------------------------------------------------------------------
void __fastcall TFormEditorForm::RefreshAdd(_di_IOTAComponent c,TTreeNode *node)
{ bool issel=false, iscreateparent=false;
  for (int i=0; i<fe->GetSelCount(); i++)
  { if (fe->GetSelComponent(i)==c) issel=true;
  }
  if (fe->GetCreateParent()==c) iscreateparent=true;
  AnsiString s=GetComponentNameOTA(fe,c)+":"+c->GetComponentType();
  if (issel && !iscreateparent) s=s+" (sel)";
  else if (!issel && iscreateparent) s=s+" (parent)";
  else if (issel && iscreateparent) s=s+" (sel,parent)";
  s=s+" @0x"+IntToHex((int)c->GetComponentHandle(),8);
  TTreeNode *newnode=tvComponents->Items->AddChild(node,s);
  for (int i=0; i<c->GetComponentCount(); i++)
  { RefreshAdd(c->GetComponent(i),newnode);
  }
}
void __fastcall TFormEditorForm::bRefreshClick(TObject *Sender)
{ tvComponents->Items->BeginUpdate();
  tvComponents->Items->Clear();
  RefreshAdd(fe->GetRootComponent(),NULL);
  tvComponents->Items->EndUpdate();
  tvComponents->FullExpand();
  tvComponents->Selected=tvComponents->Items->GetFirstNode();
}
//---------------------------------------------------------------------------

void __fastcall TFormEditorForm::tvComponentsDblClick(TObject *Sender)
{ bGet->Click();
}
//---------------------------------------------------------------------------

void __fastcall TFormEditorForm::bGetClick(TObject *Sender)
{ if (tvComponents->Selected==NULL) {MessageBeep(0);return;}
  AnsiString s=tvComponents->Selected->Text;
  int p=s.Pos("@"); s=s.SubString(p+1,s.Length()-p);
  int handle=s.ToInt();
  _di_IOTAComponent c=fe->GetComponentFromHandle((void*)handle);
  if (c==NULL) Application->MessageBox("Internal error finding handle","Get Component",MB_OK);
  else ShowComponent(this,fe,c);
}
//---------------------------------------------------------------------------

void __fastcall TFormEditorForm::SelectComponent(_di_IOTAComponent c)
{ if (c==NULL) {tvComponents->Selected=NULL;return;}
  AnsiString shandle="@0x"+IntToHex((int)c->GetComponentHandle(),8);
  for (int i=0; i<tvComponents->Items->Count; i++)
  { if (tvComponents->Items->Item[i]->Text.Pos(shandle)!=0)
    { tvComponents->Selected=tvComponents->Items->Item[i];
      return;
    }
  }
  Application->MessageBox("Internal error finding component to select","SelectComponent",MB_OK);
}

void __fastcall TFormEditorForm::bFindClick(TObject *Sender)
{ if (eName->Text=="<name>") {Application->MessageBox("Invalid name to find. Type in a component name","Find Component",MB_OK); return;}
  _di_IOTAComponent c=fe->FindComponent(eName->Text);
  if (c==NULL) Application->MessageBox("Component not found","Find Component",MB_OK);
  else SelectComponent(c);
}
//---------------------------------------------------------------------------

void __fastcall TFormEditorForm::bCrerateClick(TObject *Sender)
{ if (eType->Text=="<type>") {Application->MessageBox("Invalid type to create. Type in a component type","Create Component",MB_OK); return;}
  int x,y,w,h;
  try
  { x=eX->Text.ToInt(); y=eY->Text.ToInt();
    w=eW->Text.ToInt(); h=eH->Text.ToInt();
  }
  catch (EConvertError &err) {Application->MessageBox("Invalid dimensions. Type in x,y,w,h dimensions","Create Component",MB_OK); return;}
  if (tvComponents->Selected==NULL) {Application->MessageBox("Invalid container. Click on a container for this new component","Create Component",MB_OK); return;}
  if (tvComponents->Selected!=tvComponents->Items->GetFirstNode())
  { int res=Application->MessageBox("Warning! You have selected not-the-root to be container for your new component.\r\nThis is unusual!\r\nAre you sure you want to continue?","Create Component",MB_YESNOCANCEL);
    if (res!=IDYES) return;
  }
  AnsiString conts=tvComponents->Selected->Text;
  int p=conts.Pos("@"); conts=conts.SubString(p+1,conts.Length()-p); int handle=conts.ToInt();
  _di_IOTAComponent contc=fe->GetComponentFromHandle((void*)handle);
  if (contc==NULL) {Application->MessageBox("Internal error finding handle for container","Get Component",MB_OK); return;}
  _di_IOTAComponent c=fe->CreateComponent(contc,eType->Text,x,y,w,h);
  if (c==NULL) Application->MessageBox("Failed to create component","Create Component",MB_OK);
  bRefresh->Click();
  SelectComponent(c);
}
//---------------------------------------------------------------------------


void __fastcall TFormEditorForm::bAddNotifierClick(TObject *Sender)
{ ShowFormNotifier(fe);
}
//---------------------------------------------------------------------------

