#include "otabrowse5.h"
#pragma hdrstop

#include "projectoptions.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TProjectOptionsForm *ProjectOptionsForm;
//---------------------------------------------------------------------------
__fastcall TProjectOptionsForm::TProjectOptionsForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TProjectOptionsForm::bRefreshClick(TObject *Sender)
{ int i=lbOptions->ItemIndex;
  lbOptions->Items->BeginUpdate();
  lbOptions->Clear();
  TOTAOptionNameArray ona = po->GetOptionNames();
  for (int i=0; i<ona.Length; i++)
  { AnsiString name=ona[i].Name;
    Typinfo::TTypeKind kind=ona[i].Kind;
    Variant v=po->GetOptionValue(name);
    AnsiString sv=VariantToString(v,kind);
    lbOptions->Items->Add(name+":"+KindToString(kind)+" = "+sv);
  }
  lbOptions->Items->EndUpdate();
  if (i<lbOptions->Items->Count) lbOptions->ItemIndex=i;
  //
  xModified->Checked=po->ModifiedState;
}
//---------------------------------------------------------------------------
void __fastcall TProjectOptionsForm::FormShow(TObject *Sender)
{ bRefresh->Click();
}
//---------------------------------------------------------------------------
void __fastcall TProjectOptionsForm::bModifiedClick(TObject *Sender)
{ po->ModifiedState=xModified->Checked;

}
//---------------------------------------------------------------------------
void __fastcall TProjectOptionsForm::bEditClick(TObject *Sender)
{ TStringList *sl=new TStringList(); sl->Assign(lbOptions->Items);
  po->EditOptions();
  bRefresh->Click();
  int diff=-1;
  for (int i=0; diff==-1 && i<lbOptions->Items->Count; i++)
  { if (lbOptions->Items->Strings[i]!=sl->Strings[i]) diff=i;
  }
  if (diff!=-1) lbOptions->ItemIndex=diff;
}
//---------------------------------------------------------------------------
void __fastcall TProjectOptionsForm::lbOptionsClick(TObject *Sender)
{ eName->Text=""; eValue->Text=""; cbType->ItemIndex=-1;
  TOTAOptionNameArray ona = po->GetOptionNames();
  int i=lbOptions->ItemIndex; if (i==-1 || i>=ona.Length) return;
  Typinfo::TTypeKind kind=ona[i].Kind; cbType->ItemIndex=cbType->Items->IndexOf(KindToString(kind));
  eName->Text=ona[i].Name;
  Variant v=po->Values[ona[i].Name];
  eValue->Text=VariantToString(v,kind);
}
//---------------------------------------------------------------------------

void __fastcall TProjectOptionsForm::bSetValueClick(TObject *Sender)
{ Typinfo::TTypeKind kind=tkUnknown;
  if (cbType->Text=="tkString") kind=tkString;
  if (cbType->Text=="tkLString") kind=tkLString;
  if (cbType->Text=="tkInteger") kind=tkInteger;
  if (cbType->Text=="tkEnumeration") kind=tkEnumeration;
  if (kind==tkUnknown) {Application->MessageBox("Setting that type is not yet implemented","Set Value",MB_OK); return;}
  switch (kind)
  { case tkString: case tkLString:
    { AnsiString val=eValue->Text; po->SetOptionValue(eName->Text,val);
    } break;
    case tkInteger: case tkEnumeration:
    { int val=eValue->Text.ToInt(); po->SetOptionValue(eName->Text,val);
    } break;
  }
  //
  int oldpos=lbOptions->ItemIndex;
  bRefresh->Click();
  int found=-1; TOTAOptionNameArray ona = po->GetOptionNames();
  for (int i=0; found==-1 && i<ona.Length; i++) {if (ona[i].Name==eName->Text) found=i;}
  if (found!=-1) lbOptions->ItemIndex=found; else lbOptions->ItemIndex=oldpos;
}
//---------------------------------------------------------------------------

